
'This is a combination of the PTP_GraphicsDemo.spin object by RaysLogic and the CYWM6935_Spec_An object v1.0 by Pat Daderko (DogP)

''Brought together by Hugh Neve     

'PTP Graphics Demo (C) Copyright 2009 Rayslogic.com, LLC
'Version 1.0a
'The Propeller Graphics Demo adapted for the PTP 3.5" Screen

CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


  'LCD is 320x240 giving 20x15 tiles
  cols = 20
  rows = 15
  screensize = cols * rows

CON  'Constants for Graphics Demo 
  _stack = ($3000 + 200+2*screensize) >> 2   'accomodate display memory and stack  
  x_tiles = 16
  y_tiles = 12

  paramcount = 14  
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 2

  GraphicsXOffset=2
  GraphicsYOffset=2



  'From CYWM6935_Spec_An object v1.0:

  ''CYWM6935 Pin Definitions
    IRQ    = 0
    nRESET = 1
    MOSI   = 2
    nSS    = 3
    SCK    = 4
    MISO   = 5
    nPD    = 6    

    ''Commands
    WRITE_REG = %10000000
    READ_REG  = %00000000

    ''Register Definitions
    REG_ID             = $00
    REG_CONTROL        = $03
    REG_DATA_RATE      = $04
    REG_CONFIG         = $05
    REG_SERDES_CTL     = $06
    REG_RX_INT_EN      = $07
    REG_RX_INT_STAT    = $08
    REG_RX_DATA_A      = $09
    REG_RX_VALID_A     = $0A
    REG_RX_DATA_B      = $0B
    REG_RX_VALID_B     = $0C
    REG_TX_INT_EN      = $0D
    REG_TX_INT_STAT    = $0E
    REG_TX_DATA        = $0F
    REG_TX_VALID       = $10
    REG_PN_CODE        = $11 '$11 to $18
    REG_THRESHOLD_L    = $19
    REG_THRESHOLD_R    = $1A
    REG_WAKE_EN        = $1C
    REG_WAKE_STAT      = $1D    
    REG_ANALOG_CTL     = $20
    REG_CHANNEL        = $21
    REG_RSSI           = $22
    REG_PA             = $23
    REG_CRYSTAL_ADJ    = $24
    REG_VCO_CAL        = $26
    REG_PWR_CTL        = $2E
    REG_CARRIER_DETECT = $2F
    REG_CLOCK_MANUAL   = $32
    REG_CLOCK_ENABLE   = $33
    REG_SYN_LOCK_CNT   = $38
    REG_MID            = $3C '$3C to $3F

    
    ofset = -130
    scala = 4
    scalb =2
VAR

  long  lcd_status      'status: off/visible/invisible  read-only       (5 contiguous longs)
  long  lcd_enable      'enable: off/on                 write-only
  long  lcd_videobase   'video base @word               write-only
  long  lcd_colorbase   'color base @long               write-only
  long  lcd_backlight   'Used to control LCD backlight

  word  screen[screensize]
  long  col, row, color
  long  boxcolor,ptr

  'Buffers for storing the values from the CYWM6935. One is required for the 'raw' values, the other for the
  'peak-hold values
  byte buffer[128]
  byte bufferx[128]
  
OBJ    'Objects for Graphics Demo
  'mouse : "mouse"
  gr    : "graphics"

OBJ

  lcd : "PTP_LcdDriver"  'Modified to drive 3.5" TFT    
  SPI : "SPI_Asm"        ' SPI driver from DogP's CYWM6935 object - based upon Beau Schwabe's
pub Main
  'Start up Display
  'clear screen
  print($100)
  'start driver
  lcd_enable:=1
  lcd_videobase := @screen
  lcd_colorbase := @vgacolors
  lcd_backlight:=16  '1=bright, 16=medium, 32=dark
  lcd.start(@lcd_status)
  col:=1
  

  waitcnt(cnt+clkfreq)

  GraphicsDemo


PUB GraphicsDemo|i,j,k,dx,dy, kk, pp, pq, rr, numx, numchr,GraphicsColor, peakhold, cursor, ii, level
  'init colors
  GraphicsColor:=16 'Using this color for graphics colors
  'Trying to sorta match the color gradient in the real version...
  vgacolors[GraphicsColor+0]:= $0CFC0000+%%0210_0000
  vgacolors[GraphicsColor+1]:= $0CFC0000+%%0210_0000  
  vgacolors[GraphicsColor+2]:= $0CFC0000+%%0210_0000  
  vgacolors[GraphicsColor+3]:= $0CFC0000+%%1210_0000  
  vgacolors[GraphicsColor+4]:= $0CFC0000+%%1220_0000     
  vgacolors[GraphicsColor+5]:= $0CFC0000+%%1220_0000  
  vgacolors[GraphicsColor+6]:= $0CFC0000+%%1120_0000  
  vgacolors[GraphicsColor+7]:= $0CFC0000+%%2120_0000  
  vgacolors[GraphicsColor+8]:= $0CFC0000+%%2130_0000  
  vgacolors[GraphicsColor+9]:= $0CFC0000+%%2030_0000  
  vgacolors[GraphicsColor+10]:=$0CFC0000+%%3030_0000  
  vgacolors[GraphicsColor+11]:=$0CFC0000+%%3030_0000  

  'init tile screen
  repeat dx from 0 to x_tiles - 1
    repeat dy from 0 to y_tiles - 1
      screen[(dy+GraphicsYOffset) * cols + dx+GraphicsXOffset]:= display_base >> 6 + dy + dx * y_tiles +(GraphicsColor+dy)<<10'((GraphicsColor+dy) & $3F)<<10



  SPI.start(15,0)

     
  'start and setup graphics
  gr.start
  gr.setup(16, 12, 128, 96, bitmap_base)

 

    'clear bitmap
    gr.clear
    gr.colorwidth(3,0)
    gr.textmode(1,1,6,5)
    gr.colorwidth(1,1)
    
     
    'copy bitmap to display
    gr.copy(display_base)





    ' From this point onwards is modified version of DogP's CYWM6935_Spec_An object
    
    LOW(nPD)                                            'Hold in reset until ready    
    HIGH(nSS)                      
    HIGH(nRESET)                   
    waitcnt(cnt+clkfreq/100)                            'wait for everything to stablilze
    HIGH(nPD)
    waitcnt(cnt+clkfreq/100)                            'wait for power up

    ''peak hold option    - either holds peak or shows trend
    peakhold := 0               ' Hold peak
    'peakhold := 1              'Show decaying trend
    
    
            
     
    ''verify communication to module is good (check ID register) 
    if ReadReg(REG_ID) == $7 'good communication
      ''set up options
      WriteReg(REG_CLOCK_MANUAL, $41)
       
      WriteReg(REG_CLOCK_ENABLE, $41)        
      WriteReg(REG_CONTROL, $10)
      WriteReg(REG_ANALOG_CTL, $40)                  
      WriteReg(REG_CARRIER_DETECT, $80)
      
      ''main loop
      repeat
        
         gr.copy(display_base) 
          
        ''cycle though all channels  
        repeat ii from 0 to 127
          ''buffer RSSI values (creates the fastest sweep to get as instantaneous of a reading as possible, and a faster draw)
          WriteReg( REG_CHANNEL, ii)                                            'select channel         
          WriteReg( REG_CONTROL, $90)                                           'enable receiver
          level := ReadReg( REG_RSSI )&$1F                                      'get RSSI value
          if level>buffer[ii]
            buffer[ii] := level                                                 'update value for peakhold function
          else
           if buffer[ii] >0 and (NOT peakhold)                                  'allow held value to decay if peakhold == 0
             buffer[ii]--
             
          bufferx[ii]:=level                                                    'Store raw value
          WriteReg( REG_CONTROL, $10 ) 'disable receiver

        
        gr.clear
'        
        'Draw raw data -  as 127 vertical bars
        gr.colorwidth(2,1) 
        repeat ii from 1 to 127
          gr.plot(-130+(ii)*2, -100)
          gr.line(-130+ii*2,-100+6*bufferx[ii]) 'draw line from previous to current
        
        

        ''draw peakhold to screen
        gr.colorwidth(3,1)               
        repeat ii from 1 to 127
          gr.plot(-130+(ii-1)*2, -100+6*buffer[ii-1])
          gr.line(-130+ii*2,-100+6*buffer[ii]) 'draw line from previous to current
        

        
        
        
       'copygraphics      
    else 'bad communication
      gr.text(-90,50,string("Failed to connect to module"))
      gr.copy(display_base)   
      repeat
  

    

PRI PrintStr(stringptr)

'' Print a zero-terminated string

  repeat strsize(stringptr)
    print(byte[stringptr++])

PUB print(c) | i, k

  case c
    $00..$FF:           'character?
      k := color << 1 + c & 1
      i := k << 10 + $200 + c & $FE
      screen[row * cols + col] := i
      screen[(row + 1) * cols + col] := i | 1
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@screen, $220, screensize)
      col := row := 0

    $108:               'backspace?
      if col
        col--

    $10D:               'return?
      newline

    $110..$11F:         'select color?
      color := c & $F


' New line
PUB copyGraphics
    gr.copy(display_base)

PUB WriteReg(reg, val)
  ''Write CYWM6935 Register
    LOW(nSS)
    SPI.SHIFTOUT(MOSI, SCK, SPI#MSBFIRST , 8, WRITE_REG|reg)
    SPI.SHIFTOUT(MOSI, SCK, SPI#MSBFIRST , 8, val)
    HIGH(nSS)

PUB ReadReg(reg)|rcv_byte
  ''Read CYWM6935 Register
    LOW(nSS)
    SPI.SHIFTOUT(MOSI, SCK, SPI#MSBFIRST , 8, READ_REG|reg)
    rcv_byte := SPI.SHIFTIN(MISO, SCK, SPI#MSBPRE, 8)
    HIGH(nSS)    
    return rcv_byte
     
PUB HIGH(Pin)
  ''Make pin output and write high
    dira[Pin]~~
    outa[Pin]~~
         
PUB LOW(Pin)
  ''Make pin output and write low
    dira[Pin]~~
    outa[Pin]~
PRI newline : i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
'      wordmove(@screen[i*cols], @screen[(i+2)*cols], cols)
    'clear new line
'    wordfill(@screen[(rows-2)*cols], $200, cols<<1)


' Data

DAT

vgacolors               long
                        long    $F00CF00C'$F00CF00C       'blue background with yellow letters
                        long    $F0F00C0C'$F0F00C0C
                        long    $08A808A8       'green
                        long    $0808A8A8
                        long    $50005000       'blue
                        long    $50500000
                        long    $FC00FC00       'white
                        long    $FCFC0000
                        long    $FF80FF80       'red/white
                        long    $FFFF8080
                        long    $FF20FF20       'green/white
                        long    $FFFF2020
                        long    $FF28FF28       'cyan/white
                        long    $FFFF2828
                        long    $00A800A8       'grey/black
                        long    $0000A8A8
                        long    $0CFCC000      'Colors for Graphics
spcl                    long    $30100020       'greenbox
                        long    $3C142828       'cyanbox
                        long    $FC54A8A8       'greybox
                        long    $3C14FF28       'cyanbox+underscore
                        long    0 [16]

DAT 'data for Graphics_Demo

vecdef                  word    $4000+$2000/3*0         'triangle
                        word    50
                        word    $8000+$2000/3*1+1
                        word    50
                        word    $8000+$2000/3*2-1
                        word    50
                        word    $8000+$2000/3*0
                        word    50
                        word    0

vecdef2                 word    $4000+$2000/12*0        'star
                        word    50
                        word    $8000+$2000/12*1
                        word    20
                        word    $8000+$2000/12*2
                        word    50
                        word    $8000+$2000/12*3
                        word    20
                        word    $8000+$2000/12*4
                        word    50
                        word    $8000+$2000/12*5
                        word    20
                        word    $8000+$2000/12*6
                        word    50
                        word    $8000+$2000/12*7
                        word    20
                        word    $8000+$2000/12*8
                        word    50
                        word    $8000+$2000/12*9
                        word    20
                        word    $8000+$2000/12*10
                        word    50
                        word    $8000+$2000/12*11
                        word    20
                        word    $8000+$2000/12*0
                        word    50
                        word    0

pixdef                  word                            'crosshair
                        byte    2,7,3,3
                        word    %%00333000,%%00000000
                        word    %%03020300,%%00000000
                        word    %%30020030,%%00000000
                        word    %%32222230,%%00000000
                        word    %%30020030,%%02000000
                        word    %%03020300,%%22200000
                        word    %%00333000,%%02000000

pixdef2                 word                            'dog
                        byte    1,4,0,3
                        word    %%20000022
                        word    %%02222222
                        word    %%02222200
                        word    %%02000200